Package org.jcsp.plugNplay.ints

# Class XorInt

java.lang.Object
org.jcsp.plugNplay.ints.XorInt

All Implemented Interfaces:
  `CSProcess`

public final class XorInt extends Object implements CSProcess
Bitwise xors two integer streams to one stream.

## Process Diagram

        in0  ________
       -->--|        | out
        in1 | XorInt |-->--
       -->--|________|

## Description

`XorInt` is a process whose output strean is the bitwise xor of the integers on its input streams.

## Channel Protocols

Input Channels
in1,in2 | int | All channels in this package carry integers.
Output Channels
out | int | All channels in this package carry integers.

## Example

The following example shows how to use this process in a small program. The program also uses some of the other building block processes. It generates a sequence of numbers, XORs them with `Integer.MAX_VALUE` to give a decending sequence of numbers (from `Integer.MAX_VALUE`) and prints this on the screen.

     import org.jcsp.lang.*;
     import org.jcsp.plugNplay.ints.*;

     public class XorIntExample {

       public static void main (String[] argv) {

         One2OneChannelInt a = Channel.one2oneInt ();
         One2OneChannelInt b = Channel.one2oneInt ();
         One2OneChannelInt c = Channel.one2oneInt ();

         new Parallel (
           new CSProcess[] {
             new NumbersInt (a.out ()),
             new GenerateInt (b.out (), Integer.MAX_VALUE),
             new XorInt (a.in (), b.in (), c.out ()),
             new PrinterInt (c.in (), "--> ", "\n")
           }
         ).run ();

       }

     }

Author:
  P.H. Welch and P.D. Austin

## Constructor Summary

Constructors
Constructor
Description
`XorInt(ChannelInputInt in0, ChannelInputInt in1, ChannelOutputInt out)`
Construct a new XorInt process with the input Channels in0 and in1 and the output Channel out.

## Method Summary

Modifier and Type
Method
Description
`void`
`run()`
The main body of this process.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### XorInt

public XorInt(ChannelInputInt in0, ChannelInputInt in1, ChannelOutputInt out)
Construct a new XorInt process with the input Channels in0 and in1 and the output Channel out. The ordering of the Channels in0 and in1 make no difference to the functionality of this process.

Parameters:
  `in0` - The first input Channel
  `in1` - The second input Channel
  `out` - The output Channel

## Method Details

### run

public void run()
The main body of this process.

Specified by:
  `run` in interface `CSProcess`